> For the complete documentation index, see [llms.txt](https://docs.degirum.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.degirum.com/face-recognition/complete-api-reference/discovery.md).

# Discovery

{% hint style="info" %}
This API Reference is based on DeGirum Face version 1.4.1.
{% endhint %}

Discovery functions for the degirum\_face package

This module provides functions to discover:

1. Available hardware on different inference hosts
2. Compatible hardware (intersection of registry and system)
3. Compatible models based on hardware/task filters

Note: For registry hardware/tasks, use degirum\_face.model\_registry.get\_hardware() and degirum\_face.model\_registry.get\_tasks() directly.

## Functions <a href="#functions" id="functions"></a>

#### get\_compatible\_hw(inference\_host\_address='@local') <a href="#get_compatible_hw" id="get_compatible_hw"></a>

`get_compatible_hw(inference_host_address='@local')`

Get hardware types that are both in the registry AND available on the system

This is the most useful function for users - it shows what hardware they can actually use.

Parameters:

| Name                     | Type  | Description                                                                                                                                                                                                      | Default    |
| ------------------------ | ----- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------- |
| `inference_host_address` | `str` | Where to check for hardware - "@local": Local system using 'degirum sys-info' - "@cloud": DeGirum cloud using degirum.get\_supported\_devices() - "host\_ip": AI server using 'degirum sys-info --host host\_ip' | `'@local'` |

Returns:

| Type        | Description                                                              |
| ----------- | ------------------------------------------------------------------------ |
| `List[str]` | List\[str]: List of hardware types that work on both registry and system |

#### get\_system\_hw(inference\_host\_address='@local') <a href="#get_system_hw" id="get_system_hw"></a>

`get_system_hw(inference_host_address='@local')`

Get hardware available on a specific inference host

Parameters:

| Name                     | Type  | Description                                                                                                                                                                                                                    | Default    |
| ------------------------ | ----- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ---------- |
| `inference_host_address` | `str` | Where to check for hardware - "@local": Local system using degirum.get\_supported\_devices() - "@cloud": DeGirum cloud using degirum.get\_supported\_devices() - "host\_ip": AI server using degirum.get\_supported\_devices() | `'@local'` |

Returns:

| Type        | Description                                                                                                                  |
| ----------- | ---------------------------------------------------------------------------------------------------------------------------- |
| `List[str]` | List\[str]: List of available hardware types (e.g., \['HAILORT/HAILO8', 'TFLITE/CPU']) Returns empty list if detection fails |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.degirum.com/face-recognition/complete-api-reference/discovery.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
